#!/bin/sh

. alterator-service-functions

SNORT_CONFIG=/etc/snort/snort.conf
MYSQL=/usr/bin/mysql
SNORT=/usr/sbin/snort
SYSCONFIG_FILE=/etc/sysconfig/snort
BARNYARD2_CONFIG=/etc/barnyard2/barnyard2.conf
BASE_DIR=/var/www/webapps/BASE/base

is_mysqld_enabled()
{
    # Ensure that mysqld was fully initialized
    service_wait mysqld

    service_control mysqld status
}

# '$' is not valid symbol in snort.conf
while [ -z "$pass" ] || echo "$pass" | grep -qs '\$'; do
    pass=`/usr/bin/pwqgen`
done

control MySQL-server nograntnonet
if is_mysqld_enabled; then
    service_start_wait mysqld restart
else
    service_start_wait mysqld start
fi

echo 'select 1;' | mysql &>/dev/null
STATUS=$?
i=0
while [ $i -lt 20 ] && [ "$STATUS" != "0" ]; do
    echo "select 1" | mysql &>/dev/null
    STATUS=$?
    let i=i+1
    if [ "$STATUS" -ge "1" ]; then
        sleep 1
    fi
done

MYSQL_ROOTPASS=`echo "select Password from user where user='root'" | mysql mysql | grep -v ^$ | grep -v ^Password`
echo "update user set Password = '' where user='root'" | mysql mysql

control MySQL-server grantnonet
service_start_wait mysqld restart

STATUS=1
i=0
while [ "$STATUS" != "0" ] && [ $i -lt 10 ]; do
    sleep 1
    i="$(($i+1))"
    echo "DROP DATABASE IF EXISTS snort;" | $MYSQL
    echo "CREATE DATABASE snort;" | $MYSQL
    STATUS=$?
done

$MYSQL -D snort -u root < /usr/share/barnyard2/schemas/create_mysql
[ -r "$BASE_DIR/sql/create_base_tbls_mysql.sql" ] && $MYSQL -D snort -u root < "$BASE_DIR"/sql/create_base_tbls_mysql.sql
echo "CREATE TABLE alterator_email (id INT UNSIGNED NOT NULL AUTO_INCREMENT, email TEXT, PRIMARY KEY (id));" | $MYSQL -D snort -u root
echo "CREATE TABLE alterator_notifications (id INT UNSIGNED NOT NULL AUTO_INCREMENT, email_id INT UNSIGNED NOT NULL, sig_class_id INT UNSIGNED NOT NULL, PRIMARY KEY (id));" | $MYSQL -D snort -u root
echo "CREATE TABLE alterator_last (sid INT UNSIGNED NOT NULL, last_cid INT UNSIGNED NOT NULL);" | $MYSQL -D snort -u root

# XXX: do not grant UPDATE,DELETE for all database
echo "GRANT INSERT,SELECT,UPDATE,DELETE on snort.* to snort@localhost identified by \"$pass\";" | $MYSQL snort

echo "update user set Password = '$MYSQL_ROOTPASS' where user='root'" | mysql mysql
MYSQL_ROOTPASS=

find_pattern="output database: log, mysql, user=snort|output alert_syslog"
output_database="output database: log, mysql, user=snort password=$pass dbname=snort host=localhost"
output_syslog="output alert_syslog: LOG_ALERT"

if egrep "^[[:blank:]]*($find_pattern)" "$BARNYARD2_CONFIG" > /dev/null 2>&1;
then
    sed -r -i "/^[[:blank:]]*($find_pattern)/d" "$BARNYARD2_CONFIG"
    sed -i "/^# Added by reset-snort-db.sh\$/d" "$BARNYARD2_CONFIG"
    echo "# Added by reset-snort-db.sh" >> "$BARNYARD2_CONFIG"
    echo "$output_database" >> "$BARNYARD2_CONFIG"
    echo "$output_syslog" >> "$BARNYARD2_CONFIG"
fi

if [ -d "$BASE_DIR" ];
then
	cp "/usr/share/alterator-snort/base_conf.php" "$BASE_DIR" &&
		sed -i "s/^[ \t]*\$alert_password =.*/\ \ \ \ \$alert_password = '$(printf "%q" "$pass")';/" "$BASE_DIR/base_conf.php"
fi
