(define-module (ui snort statistics ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :export (init))

(define (set-status)
  (for-each (lambda(p) (form-update-value p ""))
            '("label_listen_at"
              "label_stopped_at"
              "label_b_listen_at"
              "label_b_stopped_at"))
  (catch/message
    (lambda()
      (let* ((data (woo-read-first "/snort/status" 'language (form-value "language"))))
        (form-update-value-list '("label_listen_at"
                                  "label_stopped_at"
                                  "label_b_listen_at"
                                  "label_b_stopped_at")
                                data)))))

(define (read-statistics)
  (set-status)
  (catch/message
    (lambda()
      (form-update-enum "statistics" (woo-list "/snort/events"
                                               'start_date (form-value "start_date")
                                               'start_time (form-value "start_time")
                                               'end_date (form-value "end_date")
                                               'end_time (form-value "end_time"))))))

(define (ui-init)
  (form-update-enum "statistics" '())
  (form-update-enum "details" '())
  (catch/message
    (lambda()
      (form-update-value-list '("start_date" "start_time" "end_date" "end_time")
                              (woo-read-first "/snort/dates"
                                              'language (form-value "language")))))
  (read-statistics))

(define (on-show)
  (read-statistics))

(define (on-details)
  (catch/message
    (lambda()
      (form-update-enum "details" (woo-list "/snort/details"
                                            'details (form-value "statistics")
                                            'start_date (form-value "start_date")
                                            'start_time (form-value "start_time")
                                            'end_date (form-value "end_date")
                                            'end_time (form-value "end_time"))))))

(define (init)
  (form-bind "details_button" "click" on-details)
  (form-bind "show_button" "click" on-show)
  (ui-init))

; vim: ft=lisp expandtab
